world
	loop_checks=0	//Be carful with this off

var/CHECKANS = 0
var/OUTPUT_STYLE = 0

client
	Topic(href,href_list[],hrsc=src)
		if(hrsc)
			switch(href)
				if("add")
					BN_Add()
				if("subtract")
					BN_Subtract()
				if("multiply")
					BN_Multiply()
				if("divide")
					BN_Divide()
				if("compare")
					BN_Compare()
				if("round")
					BN_Round()
				if("fact")
					BN_Factorial()
				if("getpi")
					Get_PI()
				if("chkans")
					Set_CheckAnswers()
				if("mkbn")
					Make_Bignum()
				if("getnum")
					Get_NumParts()
				if("setdiv")
					Set_Dividers()
				if("setfloat")
					Set_Float()

client/verb
	Set_Dividers()
		alert(src,"You can set the separators used to make reading the digits easier\n\
			There are 2 you can set:\n\
			* The Decimal Place\n\
			* The Thousands separator\n\
			Example: 123,456,78.3422\n\
			<.> is the decimal separator\n\
			<,> is the thousands separator\n\n\
			NOTE: They cannot be set to the same thing but they can be null\n\
			      Also, what you set these as effects what how bignum are created","Set Dividers",)
		var/dp = input(src,"Please enter the decimal point","Decimal Point") as text
		var/is = input(src,"Please enter the thousands separator","Thousands Separator") as text
		bn_setSeparators(dp,is)

		world << "Decimal Place = {[DECPOINT]}"
		world << "Integer Separator = {[INTSEP]}"
		world << "Example: [bString("12345678[DECPOINT]9876")]"

client/verb
	Set_Float()
		alert(src,"You can set the number of decimal places that are displayed in output\nThe default is 12\nThere has to be a limit because some operations could result in an infinite number of digits","Set Float",)
		var/n = input(src,"Please enter a number between 0 and 100","Number") as num
		n = max(min(100,n),0)
		MAXFLOAT = n
		world << "MAXFLOAT set to [n]\n"

client/verb
	Set_CheckAnswers()
		CHECKANS = !CHECKANS
		if(CHECKANS) world << "Now when you run a math problem, Wolfram Alpha will pop up so you can verify the answer\nNote: this wont work with extremely long inputs"
		else world << "Answer checking is off"

client/proc
	checkAns(var/str)
		if(length(str)<100)
//			world << "http://www.wolframalpha.com/input/?i=[str]"
			src << link("http://www.wolframalpha.com/input/?i=[str]")
		else
			world << "String is too long to verify in WolframAlpha"

client
	New()
		src << browse('RBNdemo.html')
		return ..()

client
	verb

		/*
		 * This test randomly makes a BigNum 4 differnt ways
		 */
		Make_Bignum()
			alert(src,"This test makes a bignum four different ways and returns the result.\nTry it with longer numbers, there is a lack of precision with tests 1 and 3\nThis is because of BYOND's internal num type limit","Make Numbers",)
			var/n = input(src,"Please enter a number:","Number") as message
			var/starttime = world.timeofday
			world << "--Test Make Bignum--"
			var/bignum/r1 = new()
			var/bignum/r2 = new()
			var/bignum/r3 = new()
			var/bignum/r4 = new()
			r1.make(text2num(n))
			r2.make(n)
			r3.make(r1)
			r4.make(r2)
			world << "Your input  [n]"
			world << "\nTest 1 make from num"
			world << "r1  [r1.toString()]"
			world << "\nTest 2 make from text"
			world << "r2  [r2.toString()]"
			world << "\nTest 3 make from result of test 1"
			world << "r3  [r3.toString()]"
			world << "\nTest 4 make from result of test 2"
			world << "r4  [r4.toString()]"

			world << "\nThis took [(world.timeofday-starttime)/10] seconds"

		/*
		 * This test randomly makes a bigNum and returns the parts
		 */
		Get_NumParts()
			alert(src,"This test makes a random bignum and returns the result.","Make Numbers")
			var/starttime = world.timeofday
			world << "--test_getParts--"
			var/bignum/n = new("[rand(-2000,2000)][rand(1,900000)].[rand(1,900000)][rand(1,900000)]")
			world << "n [n.toString()]"
			world << "int [bn_list2text(n.intPart())]"
			world << "dec [bn_list2text(n.decPart())]"
			world << "dec places [n.decimal]"
			world << "dec pos [n.getDecimalPosition()]"
			var/txt
			for(var/i in n.digits)
				txt += "[i],"
			world << "list([txt]) Length [n.digitsLength()]"
			world << "this took [(world.timeofday-starttime)/10] seconds"

		/*
		 * Add two numbers
		 */
		BN_Add()
			var/x = input(src,"Input a number") as text
			var/y = input(src,"Input a number") as text
			var/starttime = world.timeofday
			world << "--test_add--"
			sleep()
			var/bignum
				n1 = new()
				n2 = new()
				result = new()
			n1.make(x)
			n2.make(y)
			result = n1.bigAdd(n2)
			world << "n1   [n1.toString()]"
			world << "n2 + [n2.toString()]"
			world << "   = [result.toString()]"
			world << "test took [(world.timeofday-starttime)/10] seconds\n"
			if(CHECKANS) checkAns("[n1.toString()]%2B[n2.toString()]")

		BN_Subtract()
			var/x = input(src,"Input a number") as text
			var/y = input(src,"Input a number") as text
			var/starttime = world.timeofday
			world << "--test_subtract--"
			sleep()
			var/bignum
				n1 = new()
				n2 = new()
				result = new()
			n1.make(x)
			n2.make(y)
			result = n1.bigSubtract(n2)
			world << "n1   [n1.toString()]"
			world << "n2 - [n2.toString()]"
			world << "   = [result.toString()]"
			world << "test took [(world.timeofday-starttime)/10] seconds\n"
			if(CHECKANS) checkAns("[n1.toString()]-[n2.toString()]")

		BN_Compare()
			var/x = input(src,"Input a number") as text
			var/y = input(src,"Input a number") as text
			var/starttime = world.timeofday
			world << "--test_compare--"
			sleep()
			var/bignum
				n1 = new()
				n2 = new()
			var/result = 0
			n1.make(x)
			n2.make(y)
			result = n1.bigCompare(n2)
			world << "n1   [n1.toString()]"
			world << "n2 ? [n2.toString()]"
			if(result<0) world << "-1  n1>n2"
			else if(result>0) world << "+1  n1<n2"
			else world << "0  n1=n2"
			world << "test took [(world.timeofday-starttime)/10] seconds\n"
			if(CHECKANS) checkAns("[n1.toString()]%3D[n2.toString()]")

		BN_Multiply()
			var/x = input(src,"Input a number") as text
			var/y = input(src,"Input a number") as text
			var/starttime = world.timeofday
			world << "--test_multiply--"
			sleep()
			var/bignum
				n1 = new()
				n2 = new()
				result = new()
			n1.make(x)
			n2.make(y)
			result = n1.bigMultiply(n2)
			world << "n1   [n1.toString()]"
			world << "n2 * [n2.toString()]"
			world << "   = [result.toString()]"
			world << "test took [(world.timeofday-starttime)/10] seconds\n"
			if(CHECKANS) checkAns("[n1.toString()]*[n2.toString()]")

		BN_Divide()
			var/x = input(src,"Input a number") as text
			var/y = input(src,"Input a number") as text
			var/starttime = world.timeofday
			world << "--test_divide--"
			sleep()
			var/bignum
				n1 = new()
				n2 = new()
				result = new()
			n1.make(x)
			n2.make(y)
			if(CHECKANS) checkAns("[n1.toString()]%2F[n2.toString()]")
			result = n1.bigDivide(n2)
			world << "n1   [n1.toString()]"
			world << "n2 / [n2.toString()]"
			world << "   = [result.toString()]"
			world << "test took [(world.timeofday-starttime)/10] seconds\n"


		BN_Round()
			var/x = input(src,"Input a number") as text
			var/y = input(src,"Round to how many places\nNegative for decimal places\nPositive for integer places") as num
			var/starttime = world.timeofday
			world << "--test_round--"
			sleep()
			var/bignum
				n = new()
				result = new()
			n.make(x)
			result = n.bigRound(y)
			world << "n [n.toString()]"
			if(y>0) y--
			world << "round to the [10**y] place"
			world << " = [result.toString()]"
			world << "test took [(world.timeofday-starttime)/10] seconds\n"
			if(CHECKANS)	//Need to do a little conversion to use WolframAlphas Language
				y = y>0 ? 10**(y-1) : 10**y
				if(!n.sign) y *= -1
				checkAns("round%28[n.toString()]%2C[y]%29")

		BN_Factorial()
			var/n = input(src,"Input a number") as num
			n = round(n,1)
			var/starttime = world.timeofday
			world << "--test_factorial--"
			world << "n = [n]! ="
			sleep()
			var/bignum/result = new()
			result = bn_bigFactorial(n)
			world << "[result.toString()]"
			world << "test took [(world.timeofday-starttime)/10] seconds\n"

		Get_PI()
			var/n = input(src,"How many decimal places?") as num
			var/bignum/result = bn_getPI(n)
			world << result.toString()

